# CHANGELOG

## v1.2.1 - 24 dic 2016

Minor bug fixes

## v1.1.8 - 20 dic 2016

Publish to npm as geopromos-js-sdk

To install:
```
npm i --save geopromos-js-sdk
```

To run tests:
```
mocha test/index.js
```

## v1.1.7 - 18 dic 2016

* Now there's an API to search for things in Geopromos

```typescript
interface IsearchParams {
    q:string, 
    limit?:number, 
    skip?:number, 
    lat?:number, 
    lng?:number, 
    radius?:number
};

static search(params:IsearchParams): Promise<any>;
```

Examples:

```ts
//typescript
let q = 'promoción';

// searching all
Geopromos.search({
    q,
    limit
}).then(res=>{
    results = res;
})

// searching near a place
Geopromos.search({
    q,
    limit,
    lat: 4.684465, // bogota
    lng: -74.074802  //bogota
}).then(res=>{
    results = res;
})
```


## v1.1.6 - 18 dic 2016

* Now there's an API to track the trends

```typescript
//typescript
interface IgetTrendsParams {
    lat?:number,
    lng?:number,
    countryCode?:string,
    limit?:number, 
    skip?:number
}

static getTrends(params: IgetTrendsParams):Promise<any>;
```

Examples: 

```typescript
//typescript

// get all trends globally
Geopromos.getTrends();

// get the trends from Colombia
Geopromos.getTrends({countryCode:'CO'}); 

// get trends from the country in which the user is located
Geopromos.getTrends({lat: 3.551115, lng:-76.585693,limit}); 
```


## v1.1.5 - 17 dic 2016

* Now all requests, instead of adding x-api-key header, they add a query parameter with key=_THE-API-KEY_
    * Now: http://apiurl.com/api/v1/promos/1231231?key=_THE-API-KEY_

## v1.1.4 - 16 dic 2016

1) Now it is required to call initialize('api-key') before anything. You must have a valid Geopromos API key
to work.

```js

let Geopromos = require('geopromos-js-sdk');
Geopromos.initialize('1231231');

// now you can call whatever method

Geopromos.getCategories()
.then(c=>{
    // the categories
})

```

2) Now there are tests made to the SDK

## v1.1.0 - 6 dic 2016

Passed all methods to static

## v1.0.0 - 6 dic 2016

Created the api, basic functionality to get:

- Promos near
- Products near
- Stores near
- Malls near

and also:

- Specific promo
- Specific brand
- Specific mall
- Specific store
- Specific product