/// <reference types="es6-shim" />
export interface IGeopromosQueryParams {
    limit?: number;
    skip?: number;
    radius?: number;
    lat?: number;
    lng?: number;
    categories?: string;
    subcategories?: string;
    sex?: string;
}
export interface IGeoQueryParams {
    limit?: number;
    skip?: number;
    radius: number;
    lat: number;
    lng: number;
}
export interface IStoresPromosProductsNearParams {
    limit?: number;
    skip?: number;
    radius: number;
    lat: number;
    lng: number;
    categories?: string;
    subcategories?: string;
    sex?: string;
    brandId?: string;
}
export interface IBrandsItemParams {
    limit?: number;
    skip?: number;
    categories?: string;
    subcategories?: string;
    sex?: string;
}
export declare class Auth {
    static instance: Auth;
    apiKey: string;
    constructor();
    static getInstance(): Auth;
    initialize(apiKey: string): void;
    getApiKey(): string;
}
export declare class Geopromos {
    static apiURL: string;
    static appId: string;
    static apiKey: string;
    constructor();
    static initialize(appId: string): void;
    static getCategories(): Promise<any>;
    static getSubcategories(): Promise<any>;
    static getCategoriesTree(): Promise<any[]>;
    static getMall(id: string): Promise<any>;
    static getMallsNear(params: IGeoQueryParams): Promise<any>;
    static getStore(id: string): Promise<any>;
    static getStoresNear(params: IStoresPromosProductsNearParams): Promise<any>;
    static getPromo(id: string): Promise<any>;
    static getPromosNear(params: IStoresPromosProductsNearParams): Promise<any>;
    static getProduct(id: string): Promise<any>;
    static getProductsNear(params: IStoresPromosProductsNearParams): Promise<any>;
    static getBrand(id: string): Promise<any>;
    static getBrandsProducts(brandId: string, params: IBrandsItemParams): Promise<any>;
    static getBrandsPromos(brandId: string, params: IBrandsItemParams): Promise<any>;
    static getBrandsStores(brandId: string, params: IBrandsItemParams): Promise<any>;
    static getBrandsStoresNear(brandId: string, params: IStoresPromosProductsNearParams): Promise<any>;
    static getTrends(params?: {
        lat?: number;
        lng?: number;
        countryCode?: string;
        limit?: number;
        skip?: number;
    }): Promise<any>;
    static search(params: {
        q: string;
        limit?: number;
        skip?: number;
        lat?: number;
        lng?: number;
        radius?: number;
    }): Promise<any>;
    private static _call(url, params, method?);
}
