"use strict";
var superagent = require("superagent");
var Auth = (function () {
    function Auth() {
    }
    Auth.getInstance = function () {
        if (!Auth.instance) {
            Auth.instance = new Auth();
        }
        return Auth.instance;
    };
    Auth.prototype.initialize = function (apiKey) {
        this.apiKey = apiKey;
    };
    Auth.prototype.getApiKey = function () {
        return this.apiKey;
    };
    return Auth;
}());
exports.Auth = Auth;
var Geopromos = (function () {
    function Geopromos() {
    }
    Geopromos.initialize = function (appId) {
        Geopromos.appId = appId;
        Auth.getInstance().initialize(appId);
    };
    Geopromos.getCategories = function () {
        return Geopromos._call(Geopromos.apiURL + 'categories', {});
    };
    Geopromos.getSubcategories = function () {
        return Geopromos._call(Geopromos.apiURL + 'subcategories', {});
    };
    Geopromos.getCategoriesTree = function () {
        return new Promise(function (resolve, reject) {
            Geopromos._call(Geopromos.apiURL + 'categories.json', {})
                .then(function (categories) {
                var c = JSON.parse(categories);
                resolve(c.data);
            }).catch(reject);
        });
    };
    Geopromos.getMall = function (id) {
        return Geopromos._call(Geopromos.apiURL + 'malls/' + id, {});
    };
    Geopromos.getMallsNear = function (params) {
        return Geopromos._call(Geopromos.apiURL + 'malls/near', params);
    };
    Geopromos.getStore = function (id) {
        return Geopromos._call(Geopromos.apiURL + 'stores/' + id, {});
    };
    Geopromos.getStoresNear = function (params) {
        return Geopromos._call(Geopromos.apiURL + 'stores/near', params);
    };
    Geopromos.getPromo = function (id) {
        return Geopromos._call(Geopromos.apiURL + 'promos/' + id, {});
    };
    Geopromos.getPromosNear = function (params) {
        return Geopromos._call(Geopromos.apiURL + 'promos/near', params);
    };
    Geopromos.getProduct = function (id) {
        return Geopromos._call(Geopromos.apiURL + 'products/' + id, {});
    };
    Geopromos.getProductsNear = function (params) {
        return Geopromos._call(Geopromos.apiURL + 'products/near', params);
    };
    Geopromos.getBrand = function (id) {
        return Geopromos._call(Geopromos.apiURL + 'brands/' + id, {});
    };
    Geopromos.getBrandsProducts = function (brandId, params) {
        return Geopromos._call(Geopromos.apiURL + 'brands/' + brandId + '/products', params);
    };
    Geopromos.getBrandsPromos = function (brandId, params) {
        return Geopromos._call(Geopromos.apiURL + 'brands/' + brandId + '/promos', params);
    };
    Geopromos.getBrandsStores = function (brandId, params) {
        return Geopromos._call(Geopromos.apiURL + 'brands/' + brandId + '/stores', params);
    };
    Geopromos.getBrandsStoresNear = function (brandId, params) {
        return Geopromos._call(Geopromos.apiURL + 'brands/' + brandId + '/stores/near', params);
    };
    Geopromos.getTrends = function (params) {
        if (params !== undefined && (params.lat && !params.lng || params.lng && !params.lat)) {
            console.error('please include lat:number and lng:number');
        }
        return Geopromos._call(Geopromos.apiURL + 'trends', params || {});
    };
    Geopromos.search = function (params) {
        if (params !== undefined && (params.lat && !params.lng || params.lng && !params.lat)) {
            console.error('please include lat:number and lng:number');
        }
        return Geopromos._call(Geopromos.apiURL + 'search', params);
    };
    Geopromos._call = function (url, params, method) {
        params = params || {};
        params.key = Auth.getInstance().getApiKey();
        return new Promise(function (resolve, reject) {
            superagent(method || 'GET', url)
                .query(params)
                .end(function (err, res) {
                if (err)
                    reject(err);
                resolve(res.body);
            });
        });
    };
    return Geopromos;
}());
Geopromos.apiURL = "https://geopromos-app-server.herokuapp.com/api/v1/";
exports.Geopromos = Geopromos;
